<?php
/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilité déportées      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Created on 1 août 07 by AEL Sarl for
 * 
 * osCommerce, Open Source E-Commerce Solutions
 * http://www.oscommerce.com
 *
 * Copyright (c) 2003 osCommerce
 *
 * Released under the GNU General Public License
 * 
 */
 
require('../includes/configure.php');
require(DIR_FS_CATALOG . DIR_WS_FUNCTIONS . 'database.php');
require(DIR_FS_CATALOG . DIR_WS_INCLUDES . 'database_tables.php'); 

require('includes/functions/general.php');
require('includes/functions/data.php');
require('includes/functions/image.php');

include('includes/webservice.php');
include('includes/common.php');

require('services/init_VL.php');
require('services/scheduled.php');

include('includes/classes/logger.php');

if (defined('CUSTOM_ERROR_HANDLER') && strtolower(CUSTOM_ERROR_HANDLER) == 'on') {

	function webmanager_error_handler ($errno, $errmsg, $file, $lineno, $context) {
		$logger = Logger::getInstance(dirname(__FILE__) . DIRECTORY_SEPARATOR . "webmanager.log");
		
		switch ($errno) {
			
			case E_NOTICE:
			case E_USER_NOTICE:
				$logger->info($file . " (" . $lineno . ") : " . $errmsg);
				break;
				
			case E_WARNING:
			case E_USER_WARNING:
				$logger->warning($file . " (" . $lineno . ") : " . $errmsg);
				break;
				
			case E_ERROR:
			case E_USER_ERROR:
				$logger->error($file . " (" . $lineno . ") : " . $errmsg);
				$logger->error("Erreur fatale, arrêt.");
				die();
				break;
		}
	}
	
	$old_error_handler = set_error_handler("webmanager_error_handler");
}

// disabling WSDL cache php5 only
ini_set('soap.wsdl_cache_enabled', FALSE);

// define some variables
$web_link = tep_db_connect();

$language_query = tep_db_query("SELECT directory FROM " . TABLE_LANGUAGES .
                               " WHERE languages_id = " . OPENSI_LANGUAGE);
while ($lang = tep_db_fetch_array($language_query))
	include('includes/' . $lang['directory'] . '.php');
                               
$config_query = tep_db_query("SELECT configuration_key as cfg_key, configuration_value as cfg_value" .
                             " FROM configuration" .
                             " WHERE configuration_key IN". 
                             " ('STORE_COUNTRY', 'STORE_ZONE', 'STORE_OWNER_EMAIL_ADDRESS')");
while ($config = tep_db_fetch_array($config_query))
	define($config['cfg_key'], $config['cfg_value']);
                             
/*
 * Structure of a function return value:
 * A return value is an array of arrays of arrays
 * Generaly, the OpenSI rapport is return_value[0]: it is an array
 * The OpenSI method can iterate through the rapport
 * and search for rapport[i], which is an array
 * rapport[i][0] is the operation code for the operation i
 */

// tep_db_query("SET character_set_client = 'utf8'");
$character_set_query = tep_db_query("SELECT @@character_set_database");
$character_set = tep_db_fetch_array($character_set_query);
$charset = $character_set['@@character_set_database'];

/*$server = new SoapServer(null, array('uri' => HTTP_SERVER . DIR_WS_HTTP_CATALOG . 'webservice.php',
                                     'encoding' => 'UTF-8'));*/
$server = new SoapServer(null, array('uri' => HTTP_SERVER . DIR_WS_HTTP_CATALOG . 'webservice.php',
                                     'encoding' => $charset));

                                     
$server->addFunction('testsInitiaux');
$server->addFunction('preparerSite');
$server->addFunction('uploadArticlesExistant');
$server->addFunction('uploadImage');
$server->addFunction('uploadImageFamille');
$server->addFunction('uploadImageSousFamille');
$server->addFunction('uploadImageMarque');
$server->addFunction('ajouterArticles');
$server->addFunction('ajouterImageAuSite');
$server->addFunction('majInfos');
$server->addFunction('majStocks');
$server->addFunction('majPrix');
$server->addFunction('majStatutCom');
$server->addFunction('majInfosFacture');
$server->addFunction('uploadClients');
$server->addFunction('uploadCommandes');
$server->addFunction(SOAP_FUNCTIONS_ALL);

$server->handle();

?>
